# High-level NavMesh Building Components

Here we introduce four high level components for the navigation system:

* [NavMeshSurface](NavMeshSurface.md) – for building and enabling a navmesh surface for one agent type.
* [NavMeshModifier](NavMeshModifier.md) – affects the navmesh generation of navmesh area types, based on the transform hierarchy.
* [NavMeshModifierVolume](NavMeshModifierVolume.md) – affects the navmesh generation of navmesh area types, based on volume.
* [NavMeshLink](NavMeshLink.md) – connects same or different navmesh surfaces for one agent type.

These components comprise the high level controls for building and using NavMeshes at runtime as well as edit time.

## Techniques and Patterns
* [Connecting NavMesh Surfaces](ConnectingSurfaces.md) using the NavMeshLink compoenent.


